; ##############################################################################
; ##############################################################################
; ##############################################################################
; SPCR => SPIE SPE DORD MSTR CPOL CPHA SPR1 SPR0 (SPI Control Register)			
; 																				
; SPI Mode Conditions Leading Edge Trailing eDge								
; 0 CPOL=0, CPHA=0 Sample (Rising) 	Setup (Falling)								
; 1 CPOL=0, CPHA=1 Setup (Rising) 	Sample (Falling)							
; 2 CPOL=1, CPHA=0 Sample (Falling) Setup (Rising)								
; 3 CPOL=1, CPHA=1 Setup (Falling) 	Sample (Rising)								
; 																				
; SPI2X SPR1 SPR0 	SCK Frequency												
; 0 	0 	 0 		fosc/4														
; 0 	0 	 1 		fosc/16														
; 0 	1 	 0 		fosc/64														
; 0 	1 	 1 		fosc/128													
; 1 	0 	 0 		fosc/2														
; 1 	0 	 1 		fosc/8														
; 1 	1 	 0 		fosc/32														
; 1 	1 	 1 		fosc/64														
; 																				
SPI_INITIALISIERUNG:
	sbi (SPI_MOSI_DDR),(SPI_MOSI_PIN_NR)	; PORT auf Ausgang	
	sbi (SPI_SCK_DDR) ,(SPI_SCK_PIN_NR)		; PORT auf Ausgang	
	cbi (SPI_MISO_DDR),(SPI_MISO_PIN_NR)	; PORT auf EINGANG	
	sbi (SPI_MISO_PORT),(SPI_MISO_PIN_NR)	; Pull-UP on		
	CS_HIGH				 					; HIGH (LOW=aktiv)	
	call wait_10ms							; 200ms diese PAUSE ev. wichtig		
;	rjmp SPI_TAKT_LOW
;	rjmp SPI_TAKT_HIGH
	rjmp SPI_TAKT_SUPER_HIGH
; ##############################################################################
; fosc/128																		
SPI_TAKT_LOW:
	ldi temp,(0<<SPIE)|(1<<SPE)|(0<<DORD)|(1<<MSTR)|(0<<CPOL)|(0<<CPHA)|(1<<SPR1)|(1<<SPR0)
	out SPCR,temp
	ldi temp,(0<<SPI2X)
	out SPSR,temp
ret
; ##############################################################################
SPI_TAKT_HIGH:
	ldi temp,(0<<SPIE)|(1<<SPE)|(0<<DORD)|(1<<MSTR)|(0<<CPOL)|(0<<CPHA)|(0<<SPR1)|(0<<SPR0)
	out SPCR,temp
	ldi temp,(0<<SPI2X)
	out SPSR,temp
ret
; ##############################################################################
; fosc/2																		
SPI_TAKT_SUPER_HIGH:
	ldi temp,(0<<SPIE)|(1<<SPE)|(0<<DORD)|(1<<MSTR)|(0<<CPOL)|(0<<CPHA)|(0<<SPR1)|(0<<SPR0)
	out SPCR,temp
	ldi temp,(1<<SPI2X)
	out SPSR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: TEMP																		
; OUT: TEMP																		
SPI_TX_TEMP:
	out SPDR,temp			; Start transmission of data 	
SPI_TX_RX_TEMP_w:
	WDR
	LED_GELB_ON
	in temp,SPSR
	sbrs temp,SPIF
	rjmp SPI_TX_RX_TEMP_w	; Wait for transmission complete
	LED_GELB_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




