;															
; OLED 128x128-RGB ATmega328p								
; Bernhard.Erfurt@gmx.de									
; 02/2021													
; https://www.mikrocontroller.net/topic/512881#new			
;															
; LED ROT:  ERROR											
; LED GELB: SPI-Aktivit									
; LED GRN: Lebenslicht										

; LED ROT blinkt: 			Programm Check Error			
; LED ROT+GELB blinkt: 		WDR Error						
; LED ROT+GELB+GRN blinkt: Interrupt Error					


; ATmega328p 									
.equ CPU_TAKT				= 8000000			; 8 MHz	
.include "m328pdef.inc"
.include "MACROS.asm"
; OLED-CS										
.equ OLED_CS_PIN_NR			= 0
.equ OLED_CS_DDR			= DDRB
.equ OLED_CS_PORT			= PORTB
; OLED-DC										
.equ OLED_DC_PIN_NR			= 1
.equ OLED_DC_DDR			= DDRB
.equ OLED_DC_PORT			= PORTB
; OLED-RES										
.equ OLED_RES_PIN_NR		= 2
.equ OLED_RES_DDR			= DDRB
.equ OLED_RES_PORT			= PORTB


; SPI-MOSI										
.equ SPI_MOSI_PIN_NR		= 3
.equ SPI_MOSI_DDR			= DDRB
.equ SPI_MOSI_PORT			= PORTB
; SPI-MISO										
.equ SPI_MISO_PIN_NR		= 4
.equ SPI_MISO_DDR			= DDRB
.equ SPI_MISO_PORT			= PORTB
; SPI-SCK										
.equ SPI_SCK_PIN_NR			= 5
.equ SPI_SCK_DDR			= DDRB
.equ SPI_SCK_PORT			= PORTB




; LED-GRUEN										
.equ LED_GRUEN_PIN_NR		= 5
.equ LED_GRUEN_DDR			= DDRD
.equ LED_GRUEN_PORT			= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR		= 6
.equ LED_GELB_DDR			= DDRD
.equ LED_GELB_PORT			= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR			= 7
.equ LED_ROT_DDR			= DDRD
.equ LED_ROT_PORT			= PORTD


; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						= SRAM_START+0			; START Adresse 	

.equ adr_STOPPUHR_L					= SRAM_START+4
.equ adr_STOPPUHR_H					= SRAM_START+5

.equ adr_ms_L						= SRAM_START+6
.equ adr_ms_H						= SRAM_START+7
.equ adr_ss							= SRAM_START+11
.equ adr_mm							= SRAM_START+12
.equ adr_hh							= SRAM_START+13

.equ adr_FONT						= SRAM_START+20
.equ adr_ASCII_X					= SRAM_START+21
.equ adr_ASCII_Y					= SRAM_START+22

.equ adr_ADC_0_L					=SRAM_START+30
.equ adr_ADC_0_H					=SRAM_START+31
.equ adr_ADC_1_L					=SRAM_START+32
.equ adr_ADC_1_H					=SRAM_START+33
.equ adr_ADC_2_L					=SRAM_START+34
.equ adr_ADC_2_H					=SRAM_START+35
.equ adr_ADC_3_L					=SRAM_START+36
.equ adr_ADC_3_H					=SRAM_START+37

.equ adr_ADC_VBG_L					=SRAM_START+44
.equ adr_ADC_VBG_H					=SRAM_START+45
.equ adr_ADC_BETRIEBSSPANNUNG		=SRAM_START+46


.equ adr_SRAM_CHECK					= SRAM_START+1900	; SRAM CHECK muss immer "S" sein
; REGISTER										
.def FARBE_L			= R10
.def FARBE_H			= R11

.def ERROR				= R12

.def NULL 				= R13
.def EINS			 	= R14
.def VOLL 			  	= R15

.def temp 				= R16
.def temp1 				= R17
.def temp2 				= R18
.def temp3 				= R19
.def temp4 				= R20
.def temp5 				= R21
.def temp6 				= R22
.def temp7 				= R23
.def temp8 				= R24
.def temp9 				= R25


.cseg							;Beginn eines Code-Segmentes	
.org 0							;Startadresse=0					
.org 0x0000 jmp RESET 			; Reset Handler										
.org 0x0002 jmp INTERRUPT_ERROR ; EXT_INT0 		; IRQ0 Handler						
.org 0x0004 jmp INTERRUPT_ERROR ; EXT_INT1 		; IRQ1 Handler						
.org 0x0006 jmp INTERRUPT_ERROR ; PCINT0 		; PCINT0 Handler					
.org 0x0008 jmp INTERRUPT_ERROR ; PCINT1 		; PCINT1 Handler					
.org 0x000A jmp INTERRUPT_ERROR ; PCINT2 		; PCINT2 Handler					
.org 0x000C jmp WDT 			; Watchdog Timer Handler			
.org 0x000E jmp INTERRUPT_ERROR ; TIM2_COMPA 	; Timer2 Compare A Handler			
.org 0x0010 jmp INTERRUPT_ERROR ; TIM2_COMPB 	; Timer2 Compare B Handler			
.org 0x0012 jmp TIM2_OVF 		; Timer2 Overflow Handler			
.org 0x0014 jmp INTERRUPT_ERROR ; TIM1_CAPT 	; Timer1 Capture Handler			
.org 0x0016 jmp INTERRUPT_ERROR ; TIM1_COMPA 	; Timer1 Compare A Handler			
.org 0x0018 jmp INTERRUPT_ERROR ; TIM1_COMPB 	; Timer1 Compare B Handler			
.org 0x001A jmp INTERRUPT_ERROR ; TIM1_OVF 		; Timer1 Overflow Handler			
.org 0x001C jmp INTERRUPT_ERROR ;TIM0_COMPA 	; Timer0 Compare A Handler			
.org 0x001E jmp INTERRUPT_ERROR ; TIM0_COMPB 	; Timer0 Compare B Handler			
.org 0x0020 jmp INTERRUPT_ERROR ; TIM0_OVF 		; Timer0 Overflow Handler			
.org 0x0022 jmp INTERRUPT_ERROR ; SPI_STC 		; SPI Transfer Complete Handler		
.org 0x0024 jmp INTERRUPT_ERROR ;USART_RXC 		; USART, RX Complete Handler		
.org 0x0026 jmp INTERRUPT_ERROR ; USART_UDRE 	; USART, UDR Empty Handler			
.org 0x0028 jmp INTERRUPT_ERROR ; USART_TXC 	; USART, TX Complete Handler		
.org 0x002A jmp INTERRUPT_ERROR ; ADC 			; ADC Conversion Complete Handler	
.org 0x002C jmp INTERRUPT_ERROR ; EE_RDY 		; EEPROM Ready Handler				
.org 0x002E jmp INTERRUPT_ERROR ; ANA_COMP 		; Analog Comparator Handler			
.org 0x0030 jmp INTERRUPT_ERROR ; TWI 			; 2-wire Serial Interface Handler	
.org 0x0032 jmp INTERRUPT_ERROR ; SPM_RDY 		; Store Program Memory Ready Handler

; ##############################################################################
; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR					
INTERRUPT_ERROR:
	LED_ROT_ON
	LED_GELB_ON
	LED_GELB_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GELB_OFF
	rcall WAIT_100ms
	rjmp INTERRUPT_ERROR 
; ##############################################################################
WDT:
	LED_ROT_ON
	LED_GELB_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GELB_OFF
	rcall WAIT_100ms
	rjmp WDT
; ##############################################################################
PROGRAMM_ERROR:
	CLI 										; Global Interrupt Disable
	LED_ROT_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GELB_OFF
	rcall WAIT_100ms
	rjmp PROGRAMM_ERROR
; ##############################################################################
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	call WDR_INITIALISIERUNG
	call SRAM_CLEAR			
	call STARTWERTE			
	call LED_INITIALISIERUNG
	call SPI_INITIALISIERUNG
	call ADC_INI_REF_5V	
	call TIMER2_INITIALISIERUNG_1ms
	call PROGRAMM_CHECK		
;-------------------------------------------------------------------------------
	SEI							; Interrupts freigeben			
	LED_GRUEN_ON
	call OLED_INITIALISIERUNG
	call ANZEIGE_BEGRUESSUNG
	call WAIT_1s
	call OLED_CLEAR

	call OLED_FARB_MUSTER
	call WAIT_1s
	call OLED_CLEAR

	call OLED_FARB_TEST
	call WAIT_1s
	call OLED_CLEAR


	call ASCII_TEST
	call WAIT_1s
	call OLED_CLEAR

	call OLED_CLEAR_TEST
	call WAIT_1s
	call OLED_CLEAR

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	rcall ADC_MESSEN_BETRIEBSSPANNUNG_TEMP1
	call ANZEIGE_HAUPT
	call PROGRAMM_CHECK
	call WAIT_10ms
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ADC.asm"
.include "ASCII.asm"
.include "ANZEIGE.asm"
.include "SONSTIGES.asm"
.include "SPI.asm"
.include "OLED_RGB.asm"
.include "TIMER.asm"
.include "WAIT.asm"
.include "ZAHLEN.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_1:
.db "OLED RGB ",0
TEXT_BEGRUESSUNG_2:
.db "128x128 Pixel",0
TEXT_BEGRUESSUNG_3:
.db "ATmega328p ",0
TEXT_BEGRUESSUNG_4:
.db "8 MHz 3.3V ",0
TEXT_BEGRUESSUNG_5:
.db " ",0
TEXT_BEGRUESSUNG_6:
.db "02/2021 V2 ",0
TEXT_BEGRUESSUNG_7:
.db " ",0
TEXT_BEGRUESSUNG_8:
.db " ",0


TEXT_CLEAR:
.db "CLEAR",0

TEXT_TEST:
.db "TEST ",0
